<template>
  <div>
    <validation-provider
      v-if="field.type === 'textarea'"
      v-slot="{ errors }"
      :name="field.name"
      :rules="field.rules"
    >
      <v-textarea
        :key="`input-${field.id}-textarea`"
        outlined
        v-model="v"
        :prepend-icon="field.icon"
        :error-messages="errors"
        :name="field.id"
        :label="field.name"
      />
    </validation-provider>
    <validation-provider
      v-else-if="field.mask"
      v-slot="{ errors }"
      :name="field.name"
      :rules="field.rules"
    >
      <v-text-field
        :key="`input-${field.id}-masked`"
        v-mask='mask'
        outlined
        v-model="v"
        :prepend-icon="field.icon"
        :error-messages="errors"
        :name="field.id"
        :label="field.name"
      />
    </validation-provider>
    <validation-provider
      v-else
      v-slot="{ errors }"
      :name="field.name"
      :rules="field.rules"
    >
      <v-text-field
        :key="`input-${field.id}-unmasked`"
        outlined
        v-model="v"
        :prepend-icon="field.icon"
        :error-messages="errors"
        :name="field.id"
        :label="field.name"
      />
    </validation-provider>
  </div>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue'
import { BasicField, TextField } from '../../util/field'

export default Vue.extend({
  name: 'text-field',
  props: {
    field: { type: Object, required: true } as PropOptions<BasicField & TextField>,
    value: { type: String }
  },
  data () {
    return {
      menu: false
    }
  },
  computed: {
    v: {
      get (): string {
        return this.value
      },
      set (v: string) {
        this.menu = false
        this.$emit('input', v)
      }
    },
    mask (): string | null {
      if (!this.field.mask) return null

      if (this.field.mask instanceof Function) {
        return this.field.mask(this.v)
      }

      return this.field.mask
    }
  }
})
</script>
